%{ 
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

extern int yyerror();
extern int yylex();
extern void checkgen();

extern FILE *output, *script;

%}

%union {
    int  token;
	int  number;
	char name[256];
    char expression[256];
}

%token <number>     NUMBER
%token <name>       NAME
%token <expression> EXPRESSION

%token <token>      PERIOD
%token <token>      COMMA

%token <token>      IF
%token <token>      THEN

%token <token>      AND
%token <token>      OR

%token <token>      SET
%token <token>      TO

%type <name>        name

%%

testset    : SET { fprintf(output, "#include \"ts34131.h\"\n"); fprintf(script, "#include \"ts34131.s\"\n"); } 
             conditions sequenceoftests { fprintf(output, "CatSendEnvelopeResponse(); CatExit();}"); };

conditions : condition { fprintf(output, "void main() {\n");} PERIOD | condition AND conditions;

condition  :  NAME TO name { if(strcmp($1, "Include") == 0) { fprintf(output, "#include \"%s.h\"\n", $3);}}
            | NAME TO EXPRESSION { fprintf(output, "BYTE %s[] = { %s };\n", $1, $3);};

name       : NAME { };

sequenceoftests  : test 
                 | sequenceoftests test {  }
                 ;

test          : ifphrase thenphrase PERIOD;

ifphrase      : IF { fprintf(output, "\tif(!("); } expressionsequence;

thenphrase    : THEN { fprintf(output, "\t\t&&"); }
                expressionsequence { fprintf(output, ")) {CatSendEnvelopeErrorResponse(); CatExit();}\n");};

expressionsequence : EXPRESSION { fprintf(output, "\t\t(%s)\n", $1);} | 
                     EXPRESSION { fprintf(output, "\t\t(%s) &&\n", $1);} AND expressionsequence ;

%%
